"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_server_1 = require("@angular/platform-server");
var get_injector_1 = require("../utilities/get-injector");
var html_minify_1 = require("./../utilities/html-minify");
var app_renderer_module_factory_1 = require("./app-renderer-module-factory");
var get_route_urls_1 = require("./get-route-urls");
var renderer_blog_service_1 = require("./renderer-blog.service");
var transform_html_1 = require("./transform-html");
function generateStaticSite(appModule, appComponent, routes, options, production) {
    return __awaiter(this, void 0, void 0, function () {
        function getTemplate() {
            return new Promise(function (resolve) {
                process.on('message', function (message) {
                    if (message.template) {
                        resolve(message.template);
                    }
                });
            });
        }
        function renderBlogJsonFiles() {
            var blogList = blogEntries.map(function (blogEntry) { return (__assign({}, blogEntry, { body: undefined })); });
            files.push({ path: 'blog/list.json', contents: JSON.stringify(blogList) });
            for (var _i = 0, blogEntries_1 = blogEntries; _i < blogEntries_1.length; _i++) {
                var blogEntry = blogEntries_1[_i];
                files.push({ path: blogEntry.url.substr(1) + ".json", contents: JSON.stringify(blogEntry) });
            }
        }
        function renderPage(url, document) {
            var visitors = [
                transform_html_1.removeInnerHtmlAttributes
            ];
            return platform_server_1.renderModule(appRendererModule, { url: url, document: document })
                .then(function (html) { return transform_html_1.transformHtml(html, visitors); })
                .then(function (html) { return production ? html_minify_1.minifyHtml(html) : html; })
                .then(function (html) {
                var urlWithFilename = url.endsWith('/') ? url + "index.html" : url + ".html";
                files.push({ path: urlWithFilename.substr(1), contents: html });
            });
        }
        function exit(error) {
            if (error) {
                process.send({ source: 'ng-static-site-generator', error: error.toString() });
            }
            else {
                process.send({ source: 'ng-static-site-generator', files: files });
            }
            process.exit(error ? 1 : 0);
        }
        var injector, blogService, blogEntries, appRendererModule, files, urls;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    core_1.enableProdMode();
                    return [4 /*yield*/, get_injector_1.getInjector(app_renderer_module_factory_1.appRenderModuleFactory(appModule, undefined, options, production))];
                case 1:
                    injector = _a.sent();
                    blogService = injector.get(renderer_blog_service_1.RendererBlogService);
                    blogEntries = blogService.getBlogListSync(true);
                    appRendererModule = app_renderer_module_factory_1.appRenderModuleFactory(appModule, appComponent, options, production);
                    files = [];
                    urls = [
                        '/404'
                    ].concat(get_route_urls_1.getRouteUrls(routes), blogEntries.map(function (blogEntry) { return blogEntry.url; }));
                    renderBlogJsonFiles();
                    getTemplate()
                        .then(function (template) { return Promise.all(urls.map(function (url) { return renderPage(url, template); })); })
                        .then(function () { exit(); }, function (error) { exit(error); });
                    return [2 /*return*/];
            }
        });
    });
}
exports.generateStaticSite = generateStaticSite;
//# sourceMappingURL=generate-static-site.js.map