"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getRouteUrls(routes, baseUrl) {
    if (baseUrl === void 0) { baseUrl = '/'; }
    var urls = [];
    for (var _i = 0, routes_1 = routes; _i < routes_1.length; _i++) {
        var route = routes_1[_i];
        var slash = route.path.length && !baseUrl.endsWith('/') ? '/' : '';
        var routeUrl = "" + baseUrl + slash + route.path;
        urls.push(routeUrl);
        if (route.children && route.children.length) {
            urls.push.apply(urls, getRouteUrls(route.children, routeUrl));
        }
    }
    return urls
        .filter(function (url) { return url.includes(':') === false; })
        .filter(function (url) { return url.includes('*') === false; })
        .filter(function (item, pos, self) { return self.indexOf(item) === pos; });
}
exports.getRouteUrls = getRouteUrls;
//# sourceMappingURL=get-route-urls.js.map