"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var injection_tokens_1 = require("./../injection-tokens");
var browser = typeof window !== 'undefined';
var LinkDirective = (function () {
    function LinkDirective(moduleOptions) {
        this.moduleOptions = moduleOptions;
    }
    LinkDirective.prototype.ngOnInit = function () {
        if (this.moduleOptions.openExternalLinksInNewTab && this.href !== undefined && this.href.startsWith('http')) {
            this.rel = 'noopener noreferrer';
            this.target = '_blank';
        }
        if (browser && this.rel === undefined) {
            this.rel = ''; // prevent browser from setting `rel="undefined"`
        }
        if (browser && this.target === undefined) {
            this.target = ''; // prevent browser from setting `target="undefined"`
        }
    };
    return LinkDirective;
}());
LinkDirective.decorators = [
    { type: core_1.Directive, args: [{ selector: 'a' },] },
];
/** @nocollapse */
LinkDirective.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Inject, args: [injection_tokens_1.MODULE_OPTIONS,] },] },
]; };
LinkDirective.propDecorators = {
    'href': [{ type: core_1.Input },],
    'rel': [{ type: core_1.HostBinding, args: ['rel',] },],
    'target': [{ type: core_1.HostBinding, args: ['target',] },],
};
exports.LinkDirective = LinkDirective;
//# sourceMappingURL=link.directive.js.map