import { GeneratorOptions } from './../options';
import { Task } from './task';
export declare enum BuildMode {
    Build = 0,
    Watch = 1,
    ProductionBuild = 2,
}
export declare class BuildTask implements Task {
    private options;
    readonly watch: boolean;
    readonly production: boolean;
    constructor(mode: BuildMode, options: GeneratorOptions);
    run(): Promise<any>;
    private runWebpackBuild();
    private webpackCompilerCallback(error, multiStats, resolve, reject);
    private printStats(multiStats, error?);
    private deleteUnnecessaryArtifacts();
}
