"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
function safeWriteFileSync(filePath, contents) {
    filePath = path_1.normalize(filePath);
    ensureDirectoryExists(filePath);
    fs_1.writeFileSync(filePath, contents);
}
exports.safeWriteFileSync = safeWriteFileSync;
function ensureDirectoryExists(filePath) {
    var dirPath = path_1.dirname(filePath);
    if (!fs_1.existsSync(dirPath) || !fs_1.statSync(dirPath).isDirectory()) {
        ensureDirectoryExists(dirPath);
        fs_1.mkdirSync(dirPath);
    }
}
exports.ensureDirectoryExists = ensureDirectoryExists;
//# sourceMappingURL=fs.utilities.js.map