"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var webpack_1 = require("@ngtools/webpack");
var ExtractTextPlugin = require("extract-text-webpack-plugin");
var fs_1 = require("fs");
var HtmlWebpackPlugin = require("html-webpack-plugin");
var path_1 = require("path");
var webpack = require("webpack");
var HtmlWebpackExcludeAssetsPlugin = require('html-webpack-exclude-assets-plugin');
var VirtualModuleWebpackPlugin = require('virtual-module-webpack-plugin');
var asset_names_1 = require("./asset-names");
var get_loaders_1 = require("./get-loaders");
var ng_static_site_generator_plugin_1 = require("./ng-static-site-generator-plugin");
var nodeModules = path_1.join(process.cwd(), 'node_modules');
var realNodeModules = fs_1.realpathSync(nodeModules);
var entryPoints = ['polyfills', 'styles', 'vendor', 'main'];
function generateClientAppWebpackConfig(options, watch, production) {
    var loaderOptions = {
        production: production,
        client: true,
        emitFiles: true,
        includeHash: watch === false
    };
    var polyfillsEntry = options.polyfillsPath ? { 'polyfills': options.polyfillsPath } : {};
    return {
        target: 'web',
        entry: __assign((_a = { 'main': options.mainPath, 'styles': options.stylesPath }, _a[asset_names_1.blogHashName] = asset_names_1.blogHashPath, _a), polyfillsEntry),
        output: {
            path: path_1.resolve(options.distPath),
            filename: watch ? '[name].js' : '[name].[hash].js'
        },
        resolve: {
            extensions: ['.js', '.ts']
        },
        module: {
            exprContextCritical: false,
            rules: get_loaders_1.getLoaders(loaderOptions)
        },
        plugins: [
            new VirtualModuleWebpackPlugin({
                moduleName: asset_names_1.blogHashPath,
                contents: options.blogPath
            }),
            new webpack.optimize.CommonsChunkPlugin({
                name: 'vendor',
                chunks: ['main'],
                minChunks: function (module) { return module.resource && (module.resource.startsWith(nodeModules) || module.resource.startsWith(realNodeModules)); }
            }),
            new webpack_1.AotPlugin({
                mainPath: options.mainPath,
                tsConfigPath: options.tsConfigPath,
                skipCodeGeneration: production === false,
                hostReplacementPaths: __assign({}, (options.environmentSource ? (_b = {}, _b[options.environmentSource] = options.environments[production ? 'prod' : 'dev'], _b) : {})),
                exclude: []
            })
        ].concat((production ? [new webpack.optimize.UglifyJsPlugin()] : []), (production ? [new webpack.NoEmitOnErrorsPlugin()] : []), getTemplatePlugins(options, watch, production, ['styles', 'main', 'vendor', 'polyfills']), [
            new ng_static_site_generator_plugin_1.NgStaticSiteGeneratorPlugin(options)
        ])
    };
    var _a, _b;
}
exports.generateClientAppWebpackConfig = generateClientAppWebpackConfig;
function getTemplatePlugins(options, watch, production, chunks) {
    return (production ? [new ExtractTextPlugin(watch ? 'style.css' : 'styles.[hash].css')] : []).concat([
        new HtmlWebpackPlugin({
            chunks: chunks,
            template: options.templatePath,
            filename: asset_names_1.templateAssetName,
            excludeAssets: production ? [/style.*\.js/] : [],
            chunksSortMode: function (left, right) { return entryPoints.indexOf(left.names[0]) - entryPoints.indexOf(right.names[0]); }
        }),
        new HtmlWebpackExcludeAssetsPlugin()
    ]);
}
exports.getTemplatePlugins = getTemplatePlugins;
//# sourceMappingURL=generate-client-app-webpack-config.js.map